
local map = {}
local tmap = {}
local run = false
local stept = 0
local phase = 0
local steptime = 1/4
local extendchance = 0.25
local centers = 160
local done = false
local sides = {{-1,0},{0,-1},{1,0},{0,1}}

local tileQuads = {}
local tilesetImage
local tilesetBatch

local bigfont = love.graphics.newFont(64)
local smallfont = love.graphics.newFont(10)

local function bin(left,up,right,down)
	local i = 1
	if left then i = i + 1 end
	if up then i = i + 2 end
	if right then i = i + 4 end
	if down then i = i + 8 end
	return i
end

local function debin(b)
	b = b - 1
	local left,up,right,down = false,false,false,false
	if math.mod(b,8) ~= b then
		down = true
		b = math.mod(b,8)
	end
	if math.mod(b,4) ~= b then
		right = true
		b = math.mod(b,4)
	end
	if math.mod(b,2) ~= b then
		up = true
		b = math.mod(b,2)
	end
	if math.mod(b,1) ~= b then
		left = true
		b = math.mod(b,1)
	end
	return left,up,right,down
end

function love.load()
	math.randomseed(os.time())
	for i = 1,60 do
		map[i] = {}
		tmap[i] = {}
		for j = 1,80 do
			map[i][j] = 1
			tmap[i][j] = 0
		end
	end
	tilesetImage = love.image.newImageData(180,10)
	local s = 3
	for h = 1,16 do
		local left,up,right,down = debin(h)
		for i = 0,9 do
			for j = 0,9 do
				local r,g,b,a = 255,255,255,255
				if (i == s-1 and j == s-1) or (i == s-1 and j == 10-s) or (i == 10-s and j == 10-s) or (i == 10-s and j == s-1) then
					r,g,b = 0,0,0
				elseif (i == s-1 or i == 10-s) and j < s-1 then
					if up then
						r,g,b = 0,0,0
					else
						r,g,b = 127,127,127
					end
				elseif (i == s-1 or i == 10-s) and j > 10-s then
					if down then
						r,g,b = 0,0,0
					else
						r,g,b = 127,127,127
					end
				elseif (j == s-1 or j == 10-s) and i < s-1 then
					if left then
						r,g,b = 0,0,0
					else
						r,g,b = 127,127,127
					end
				elseif (j == s-1 or j == 10-s) and i > 10-s then
					if right then
						r,g,b = 0,0,0
					else
						r,g,b = 127,127,127
					end
				elseif i < s and j < s then
					r,g,b = 127,127,127
				elseif i < s and j > 9-s then
					r,g,b = 127,127,127
				elseif i > 9-s and j < s then
					r,g,b = 127,127,127
				elseif i > 9-s and j > 9-s then
					r,g,b = 127,127,127
				elseif i > s-1 and i < 10-s and j == s-1 then
					if not up then
						r,g,b = 0,0,0
					end
				elseif i > s-1 and i < 10-s and j == 10-s then
					if not down then
						r,g,b = 0,0,0
					end
				elseif j > s-1 and j < 10-s and i == s-1 then
					if not left then
						r,g,b = 0,0,0
					end
				elseif j > s-1 and j < 10-s and i == 10-s then
					if not right then
						r,g,b = 0,0,0
					end
				elseif i > s-1 and i < 10-s and j < s-1 then
					if not up then
						r,g,b = 127,127,127
					end
				elseif i > s-1 and i < 10-s and j > 10-s then
					if not down then
						r,g,b = 127,127,127
					end
				elseif j > s-1 and j < 10-s and i < s-1 then
					if not left then
						r,g,b = 127,127,127
					end
				elseif j > s-1 and j < 10-s and i > 10-s then
					if not right then
						r,g,b = 127,127,127
					end
				end
				tilesetImage:setPixel(i+h*10-10,j,r,g,b,a)
			end
		end
		tileQuads[h] = love.graphics.newQuad( h*10-10, 0, 10, 10, 180, 10 )
	end
	for i = 0,9 do
		for j = 0,9 do
			tilesetImage:setPixel(i+160,j,127,127,127,255)
			if i == s-1 or i == 10-s then
				tilesetImage:setPixel(i+160,j,0,0,0,255)
			elseif (j == s-1 or j == 10-s) and (i < s-1 or i > 10-s) then
				tilesetImage:setPixel(i+160,j,0,0,0,255)
			elseif (i > s-1 and i < 10-s) or (j > s-1 and j < 10-s) then
				tilesetImage:setPixel(i+160,j,255,255,255,255)
			end
			
			tilesetImage:setPixel(i+170,j,127,127,127,255)
			if j == s-1 or j == 10-s then
				tilesetImage:setPixel(i+170,j,0,0,0,255)
			elseif (i == s-1 or i == 10-s) and (j < s-1 or j > 10-s) then
				tilesetImage:setPixel(i+170,j,0,0,0,255)
			elseif (i > s-1 and i < 10-s) or (j > s-1 and j < 10-s) then
				tilesetImage:setPixel(i+170,j,255,255,255,255)
			end
		end
	end
	tilesetImage = love.graphics.newImage(tilesetImage)

	for i = 1,18 do
		tileQuads[i] = love.graphics.newQuad(i*10-10,0, 10, 10,tilesetImage:getWidth(), tilesetImage:getHeight())
	end
	
	tilesetBatch = love.graphics.newSpriteBatch(tilesetImage, 80 * 60)
end

local function table_concat(t1,t2)
	for i,v in ipairs(t2) do
		table.insert(t1,v)
		t2[i] = nil
	end
	return t1
end

local function updateTiles()
	tilesetBatch:clear()
	for y = 1,60 do
		for x = 1,80 do
			if map[y][x] ~= 0 then
				tilesetBatch:addq(tileQuads[math.min(map[y][x],18)], x*10-10, y*10-10)
			end
		end
	end
end

local function switch(s)
	if s > 4 then
		return (s-1)/4+1
	else
		return (s-1)*4+1
	end
end

local function move(n)
	local l,u,r,d = debin(n)
	local p = {x=0,y=0}
	if l then p.x = p.x - 1 end
	if u then p.y = p.y - 1 end
	if r then p.x = p.x + 1 end
	if d then p.y = p.y + 1 end
	return p
end

local function absorb(g,d)
	for y = 1,60 do
		for x = 1,80 do
			if tmap[y][x] == d then
				tmap[y][x] = g
			end
		end
	end
end

local function check(x,y,t)
	if x > 0 and x < 81 and y > 0 and y < 61 then
		if map[y][x] == 1 then
			return true
		elseif tmap[y][x] ~= t then
			return true
		end
	else
		return false
	end
end

local function extend(x,y,t,n)
	-- just makes sure it's fixed correctly
	if tmap[y][x] == tmap[y+move(n).y][x+move(n).x] and tmap[y][x] ~= 0 then
	else
		map[y][x] = map[y][x] + n - 1
		map[y+move(n).y][x+move(n).x] = map[y+move(n).y][x+move(n).x] + switch(n) - 1
		tmap[y][x] = t
		if tmap[y+move(n).y][x+move(n).x] == 0 then
			tmap[y+move(n).y][x+move(n).x] = t
		else
			absorb(tmap[y][x],tmap[y+move(n).y][x+move(n).x])
		end
	end
end

local function step()
	if phase < centers then
		-- PLACE THINGS
		local t = {}
		for y = 2,59 do
			for x = 2,79 do
				if map[y][x] == 1 and map[y][x-1] == 1 and map[y-1][x] == 1 and map[y][x+1] == 1 and map[y+1][x] == 1 then
					table.insert(t,{x,y})
				end
			end
		end
		local c = math.max(math.ceil(math.random()*#t),1)
		extend(t[c][1],t[c][2],phase+1,2)
		extend(t[c][1],t[c][2],phase+1,3)
		extend(t[c][1],t[c][2],phase+1,5)
		extend(t[c][1],t[c][2],phase+1,9)
		map[t[c][2]][t[c][1]] = 16-- + math.ceil(math.random()*2)
	else
		--EXTEND SHIT
		done = true
		for y = 1,60 do
			for x = 1,80 do
				if tmap[y][x] ~= 0 and map[y][x] <= 16 then
					local l,u,r,d = check(x-1,y,tmap[y][x]),check(x,y-1,tmap[y][x]),check(x+1,y,tmap[y][x]),check(x,y+1,tmap[y][x])
					if l or u or r or d then
						done = false
					end
					if l and math.random() < extendchance then
						extend(x,y,tmap[y][x],bin(true,false,false,false))
					end
					if u and math.random() < extendchance then
						extend(x,y,tmap[y][x],bin(false,true,false,false))
					end
					if r and math.random() < extendchance then
						extend(x,y,tmap[y][x],bin(false,false,true,false))
					end
					if d and math.random() < extendchance then
						extend(x,y,tmap[y][x],bin(false,false,false,true))
					end
				end
			end
		end
		if done then run = false; print(tmap[1][1] .. " won") end
	end
	updateTiles()
	phase = phase + 1
end

local bugging = false

function love.keypressed(k)
	if k == "return" then
		run = not run
		stept = 0
	elseif k == " " then
		step()
	end
end

function love.update(dt)
	if run then
		stept = stept + dt
		if stept >= steptime then
			step()
		end
		stept = math.mod(stept,steptime)
	end
end

function love.draw()
	love.graphics.setColor(255,255,255)
	love.graphics.draw(tilesetBatch,0,0,0,1,1)
	love.graphics.setColor(0,0,255)
	love.graphics.setFont(bigfont)
	if phase == 0 then
		love.graphics.print("Spacebar to step()",5,5)
		love.graphics.print("Enter to auto step()",5,70)
	elseif not done then
		love.graphics.print(phase,0,0)
	end
end
